package main

import (
	"fmt"
	"net"
	"bytes"
	"io/ioutil"
	"unicode"
	"unicode/utf8"
	"crypto/rand"
//	"os"
)

var (
	banner []byte
)

const (
	colBlue = "\033[0;34m"
	colGreen = "\033[0;32m"
	colBGreen = "\033[1;32m"
	colCyan = "\033[0;36m"
	colBRed = "\033[1;31m"
	colBold = "\033[1;37m"
	noCol = "\033[0m"
	
	nameLen = 12
	outDir = "/var/www/write.as/data/"
)

func main() {
	ln, err := net.Listen("tcp", ":9727")
	if err != nil {
		panic(err)
	}
	fmt.Println("Listening on localhost:9727")
	
	fmt.Print("Initializing...")
	banner, _ = ioutil.ReadFile("./banner.txt")
	fmt.Println("DONE")
	
	for {
		conn, err := ln.Accept()
		if err != nil {
			fmt.Println(err)
			continue
		}
		
		go handleConnection(conn)
	}
}

func output(c net.Conn, m string) bool {
	_, err := c.Write([]byte(m))
	if err != nil {
		c.Close()
		return false
	}
	return true
}

func outputBytes(c net.Conn, m []byte) bool {
	_, err := c.Write(m)
	if err != nil {
		c.Close()
		return false
	}
	return true
}

func bye(c net.Conn) {
	output(c, "Bye!")
	c.Close()
}

func handleConnection(c net.Conn) {
	outputBytes(c, banner)
	output(c, fmt.Sprintf("\n%sWelcome to write.as!%s\n", colBGreen, noCol))
	output(c, fmt.Sprintf("If this is freaking you out, you can get notified of the %sbrowser-based%s launch\ninstead at https://write.as.\nPress %sCtrl-D%s at any time to quit.\n\n", colBold, noCol, colBold, noCol))
	
	//output("\nThat's all (for now), folks!\n")
	waitForEnter(c)
	output(c, fmt.Sprintf("Enter anything you like. When you're done, press %sCtrl-D%s to get the URL of your new post.\n", colBold, noCol))
	readInput(c)
	c.Close()
	
	fmt.Printf("Connection from %v closed.\n", c.RemoteAddr())
}

func waitForEnter(c net.Conn) {
	b := make([]byte, 2)
	
	output(c, fmt.Sprintf("%sPress Enter to continue...%s", colBRed, noCol))
	for {
		n, err := c.Read(b)
		if checkExit(b, n) {
			c.Close()
		}
		if err != nil || n == 0 {
			c.Close()
		}
		break
	}
}

func checkExit(b []byte, n int) bool {
	if n == 1 {
		runeValue, _ := utf8.DecodeRune(b[0:n])
		return unicode.IsControl(runeValue)
	}
	return false
}

func readInput(c net.Conn) {
	b := make([]byte, 4096)
	
	var post bytes.Buffer
	
	for {
		n, err := c.Read(b)
		//fmt.Print(fmt.Sprintf("read %d", n))
		post.Write(b[0:n])
		if checkExit(b, n) {
			file, err := savePost(post.Bytes())
			if err != nil {
				output(c, fmt.Sprintf("There was an error saving: %s", err))
			}
			output(c, "\nPosted! View at http://nerds.write.as/" + file + "\n\n")
			c.Close()
			break
		}
		
		if err != nil || n == 0 {
			c.Close()
			break
		}
		
		/*
		ok := outputBytes(c, b[0:n])
		if !ok {
			break
		}
		*/
	}
}

func savePost(post []byte) (string, error) {
	filename := generateFileName()
	err := ioutil.WriteFile(outDir + filename, post, 0600)
	return filename, err
}

func generateFileName() string {
	c := nameLen
	var dictionary string = "0123456789abcdefghijklmnopqrstuvwxyz"
	var bytes = make([]byte, c)
	rand.Read(bytes)
	for k, v := range bytes {
		 bytes[k] = dictionary[v%byte(len(dictionary))]
	}
	return string(bytes)
}
